From c08121e6ebc3b0ce65f931acb2d1633b75cc8702 Mon Sep 17 00:00:00 2001
From: Alec Leamas <leamas.alec@gmail.com>
Date: Wed, 20 Oct 2010 08:49:36 +0200
Subject: [PATCH] socket server update: pidfile, ubuntu upstart, bugfixes

patching websocket_server.rb to provide a pidfile, important
for SystemV init files. Ubuntu upstart configuration. Bugfixes
---
 pkg/fedora/diaspora-setup    |   7 +-
 pkg/fedora/diaspora-wsd      |   2 +-
 pkg/ubuntu/diaspora-install  |   2 +-
 pkg/ubuntu/diaspora-setup    |   6 +-
 pkg/ubuntu/diaspora-wsd      | 154 -----------------------------------
 pkg/ubuntu/diaspora-wsd.conf |  19 +++++
 script/websocket_server.rb   |   1 -
 7 files changed, 27 insertions(+), 164 deletions(-)
 delete mode 100755 pkg/ubuntu/diaspora-wsd
 create mode 100644 pkg/ubuntu/diaspora-wsd.conf

diff --git a/pkg/fedora/diaspora-setup b/pkg/fedora/diaspora-setup
index 01f0d3cdcb..0214e419aa 100755
--- a/pkg/fedora/diaspora-setup
+++ b/pkg/fedora/diaspora-setup
@@ -24,8 +24,6 @@ cd /usr/share/diaspora/master
 
 test -e config/app_config.yml ||
     cp config/app_config.yml.example config/app_config.yml
-sed -i '/socket_pidfile:/s|:.*|: /var/run/diaspora/diaspora-wsd.pid|' \
-    config/app_config.yml
 
 if rake db:seed:dev; then
     echo "Database config OK, new user tom/evankorth in place"
@@ -41,10 +39,11 @@ else
     exit 1
 fi
 
-# %attr(0777, diaspora, diaspora) doesn't work in specfile due to umask 022.
-chmod 777 /var/lib/diaspora/uploads
 chown -R diaspora /var/log/diaspora
 
+sed -i '/socket_pidfile:/s|:.*|: /var/run/diaspora/diaspora-wsd.pid|' \
+    config/app_config.yml
+
 hostname=$( awk '/pod_url:/ { print $2; exit }' <config/app_config.yml)
 
 if [ -n "$arg_hostname" ]; then
diff --git a/pkg/fedora/diaspora-wsd b/pkg/fedora/diaspora-wsd
index f99492e80a..d4ad539533 100755
--- a/pkg/fedora/diaspora-wsd
+++ b/pkg/fedora/diaspora-wsd
@@ -35,7 +35,7 @@ prog="Diaspora websocket server"
 exec="script/websocket_server.rb"
 pidfile="/var/run/diaspora/diaspora-wsd"
 lockfile="/var/lock/subsys/diaspora-wsd"
-logfile=/var/log/diaspora-wsd.log
+logfile="/var/log/diaspora/diaspora-wsd.log"
 
 [ -n "$OPTIONS" ] && OPTIONS=" $OPTIONS"
 ruby_cmd="ruby -C $PWD $exec$OPTIONS"
diff --git a/pkg/ubuntu/diaspora-install b/pkg/ubuntu/diaspora-install
index daaf33b547..0685aa3ae8 100755
--- a/pkg/ubuntu/diaspora-install
+++ b/pkg/ubuntu/diaspora-install
@@ -30,7 +30,7 @@ sed -i '/BUNDLE_PATH/s|:.*|: /usr/lib/diaspora-bundle/bundle|' \
 
 cp master/GNU-AGPL-3.0 master/COPYRIGHT master/README.md master/AUTHORS .
 cp master/config/app_config.yml.example ./app_config.yml
-cp master/pkg/ubuntu/diaspora-wsd /etc/init.d
+cp master/pkg/ubuntu/diaspora-wsd.conf /etc/init
 
 sed -i '/^cd /s|.*|cd /usr/share/diaspora/master|' /etc/init.d/diaspora-wsd
 
diff --git a/pkg/ubuntu/diaspora-setup b/pkg/ubuntu/diaspora-setup
index 305527d28b..32293a2d27 100755
--- a/pkg/ubuntu/diaspora-setup
+++ b/pkg/ubuntu/diaspora-setup
@@ -26,8 +26,6 @@ cd /usr/share/diaspora/master
 
 test -e config/app_config.yml ||
     cp config/app_config.yml.example config/app_config.yml
-sed -i '/socket_pidfile:/s|:.*|: /var/run/diaspora/diaspora-wsd.pid|' \
-    config/app_config.yml
 
 if rake db:seed:dev; then
     echo "Database config OK, new user tom/evankorth in place"
@@ -45,9 +43,11 @@ else
     exit 1
 fi
 
-chmod 777 /var/lib/diaspora/uploads
 chown -R diaspora /var/log/diaspora
 
+sed -i '/socket_pidfile:/s|:.*|: /var/run/diaspora/diaspora-wsd.pid|' \
+    config/app_config.yml
+
 hostname=$( awk '/pod_url:/ { print $2; exit }' <config/app_config.yml)
 
 if [ -n "$arg_hostname" ]; then
diff --git a/pkg/ubuntu/diaspora-wsd b/pkg/ubuntu/diaspora-wsd
deleted file mode 100755
index 0e8d08f203..0000000000
--- a/pkg/ubuntu/diaspora-wsd
+++ /dev/null
@@ -1,154 +0,0 @@
-#!/bin/sh
-### BEGIN INIT INFO
-# Provides:          diaspora-wsd
-# Required-Start:    $remote_fs $syslog
-# Required-Stop:     $remote_fs $syslog
-# Default-Start:     2 3 4 5
-# Default-Stop:      0 1 6
-# Short-Description: diaspora websocket daemon
-# Description:       The diaspora websocket service provider, normally
-#                    listening on port 8080
-### END INIT INFO
-
-# Author: Alec leamas <leamas.alec@gmail.com>
-
-PATH=/bin:/sbin:/usr/sbin:/usr/bin
-DESC="Websocket server for diaspora clients"
-NAME='diaspora-wsd'
-DAEMON='/usr/local/bin/bundle'
-DAEMON_ARGS=' exec ruby ./script/websocket_server.rb'
-PIDFILE=/var/run/diaspora/diaspora-wsd.pid
-SCRIPTNAME=/etc/init.d/diaspora-wsd
-
-cd /usr/share/diaspora/master
-
-[ -x "$DAEMON" ] || exit 0
-[ -r /etc/default/$NAME ] && . /etc/default/$NAME
-
-# Load the VERBOSE setting and other rcS variables
-. /lib/init/vars.sh
-
-# Define LSB log_* functions.
-# Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
-. /lib/lsb/init-functions
-
-#
-# Function that starts the daemon/service
-#
-do_start()
-{
-	# Return
-	#   0 if daemon has been started
-	#   1 if daemon was already running
-	#   2 if daemon could not be started
-        [ -f $PIDFILE ] && {
-            pid=$( cat $PIDFILE)
-            name=$( ps -p "$pid" -o comm= 2> /dev/null) || :
-            [ "$name" = "ruby" ] && return 1
-        }
-	start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON \
-            --chdir $PWD -- $DAEMON_ARGS \
-		|| return 2
-        return 0
-}
-
-#
-# Function that stops the daemon/service
-#
-do_stop()
-{
-	# Return
-	#   0 if daemon has been stopped
-	#   1 if daemon was already stopped
-	#   2 if daemon could not be stopped
-	#   other if a failure occurred
-	start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE \
-            --name $NAME --chdir $PWD
-	RETVAL="$?"
-	[ "$RETVAL" = 2 ] && return 2
-	# Wait for children to finish too if this is a daemon that forks
-	# and if the daemon is only ever run from this initscript.
-	# If the above conditions are not satisfied then add some other code
-	# that waits for the process to drop all resources that could be
-	# needed by services started subsequently.  A last resort is to
-	# sleep for some time.
-	start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --chdir $PWD \
-            --exec $DAEMON
-	[ "$?" = 2 ] && return 2
-	# Many daemons don't delete their pidfiles when they exit.
-	rm -f $PIDFILE
-	return "$RETVAL"
-}
-
-#
-# Function that sends a SIGHUP to the daemon/service
-#
-do_reload() {
-	#
-	# If the daemon can reload its configuration without
-	# restarting (for example, when it is sent a SIGHUP),
-	# then implement that here.
-	#
-	start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --chdir $PWD \
-        --name $NAME
-	return 0
-}
-
-case "$1" in
-  start)
-	[ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
-	do_start
-	case "$?" in
-		0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
-		2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
-	esac
-	;;
-
-  stop)
-	[ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
-	do_stop
-	case "$?" in
-		0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
-		2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
-	esac
-	;;
-
-  status)
-       status_of_proc "$DAEMON" "$NAME" && exit 0 || exit $?
-       ;;
-
-  #reload|force-reload)
-	#
-	# If do_reload() is not implemented then leave this commented out
-	# and leave 'force-reload' as an alias for 'restart'.
-	#
-	#log_daemon_msg "Reloading $DESC" "$NAME"
-	#do_reload
-	#log_end_msg $?
-	#;;
-
-  restart|force-reload)
-	log_daemon_msg "Restarting $DESC" "$NAME"
-	do_stop
-	case "$?" in
-	  0|1)
-		do_start
-		case "$?" in
-			0) log_end_msg 0 ;;
-			1) log_end_msg 1 ;; # Old process is still running
-			*) log_end_msg 1 ;; # Failed to start
-		esac
-		;;
-	  *)
-	  	# Failed to stop
-		log_end_msg 1
-		;;
-	esac
-	;;
-
-  *) echo "Usage: $SCRIPTNAME {start|stop|status|restart|force-reload}" >&2
-	exit 3
-	;;
-esac
-
-:
diff --git a/pkg/ubuntu/diaspora-wsd.conf b/pkg/ubuntu/diaspora-wsd.conf
new file mode 100644
index 0000000000..95d78118e2
--- /dev/null
+++ b/pkg/ubuntu/diaspora-wsd.conf
@@ -0,0 +1,19 @@
+# Ubuntu upstart file at /etc/init/diaspora-wsd.conf
+
+start on runlevel [5]
+stop on runlevel [06]
+
+export fork
+
+script
+  if [ -f /etc/default/diaspora ]; then
+    . /etc/default/diaspora;
+  fi;
+  cd /usr/share/diaspora/master;
+  start-stop-daemon --start           \
+      --chuid diaspora:diaspora       \
+      --chdir $PWD                    \
+      --exec "/usr/local/bin/bundle"  \
+      --  exec ruby -C $PWD script/websocket_server.rb;
+
+end script
diff --git a/script/websocket_server.rb b/script/websocket_server.rb
index 64f6ddf8a4..4dddca11e1 100644
--- a/script/websocket_server.rb
+++ b/script/websocket_server.rb
@@ -25,7 +25,6 @@ def write_pidfile
   end
 end
 
-
 CHANNEL = Magent::GenericChannel.new('websocket')
 def process_message
   if CHANNEL.queue_count > 0
-- 
GitLab